include:
  - https://gitlab.com/introspectdata/public/build-artifacts/raw/master/container-build.yml

stages:
  - prerequisites
  - setup
  - deploy
  - cleanup

build-container:
  stage: prerequisites
  extends: .container_build

k8s-setup:
  stage: setup
  image: registry.gitlab.com/introspectdata/public/k8s-maas-ansible
  tags:
    - on-prem
  environment:
    name: k8s on-prem
    url: http://172.16.32.2:5240/MAAS/
  variables:
    MAAS_URL: http://172.16.32.2:5240/MAAS/
    MASTER_TAG: k8s-master
    NODE_TAG: k8s-node
  script:
    - maas-setup prepare

k8s-deploy:
  stage: deploy
  image: registry.gitlab.com/introspectdata/public/k8s-maas-ansible
  tags:
    - on-prem
  environment:
    name: k8s on-prem
    url: http://172.16.32.2:5240/MAAS/
  variables:
    MAAS_URL: http://172.16.32.2:5240/MAAS/
    MASTER_TAG: k8s-master
    NODE_TAG: k8s-node
    ANSIBLE_HOST_KEY_CHECKING: "False"
    ANSIBLE_CONFIG: $CI_PROJECT_DIR/ansible.cfg
  script:
    - mkdir -p ~/.ssh
    - echo -n $MAAS_SSH_KEY | base64 --decode > ~/.ssh/id_rsa
    - chmod 400 ~/.ssh/id_rsa
    - ./maas --reset
    - ansible-playbook -vvv -i maas k8s-01-base.yaml
    - ansible-playbook -vvv -i maas k8s-02-install.yaml
    - ansible-playbook -vvv -i maas k8s-03-common.yaml

k8s-cleanup:
  stage: cleanup
  when: always
  image: registry.gitlab.com/introspectdata/public/k8s-maas-ansible
  tags:
    - on-prem
  environment:
    name: k8s on-prem
    url: http://172.16.32.2:5240/MAAS/
  variables:
    MAAS_URL: http://172.16.32.2:5240/MAAS/
    MASTER_TAG: k8s-master
    NODE_TAG: k8s-node
  script:
    - maas-setup cleanup
